/* tslint:disable */


//from http://stackoverflow.com/questions/901115/how-can-i-get-query-string-values-in-javascript


declare var CryptoJS:any;

function getParameterByName(name: string, url?: string) {
  if (!url) url = window.location.href;
  name = name.replace(/[\[\]]/g, "\\$&");
  var regex = new RegExp("[?&]" + name + "(=([^&#]*)|&|#|$)"),
    results = regex.exec(url);
  if (!results) return null;
  if (!results[2]) return '';
  return decodeURIComponent(results[2].replace(/\+/g, " "));
}

function externalRegister() {

  const registerBtn = document.getElementById('registerButton')
  registerBtn.classList.add("loading")

  if (!CryptoJS) {
    alert('Cryptojs not found!\nCannot create external user (and set password).')
    return
  }

  const pwInput: HTMLInputElement = <HTMLInputElement>document.getElementById('password')
  const pwWdhInput: HTMLInputElement = <HTMLInputElement>document.getElementById('passwordWdh')

  const pw = pwInput.value
  const pwWdh = pwWdhInput.value

  if (pw === '') {
    alert('Password must not be empty!')
    registerBtn.classList.remove("loading")
    return
  }

  if (pw !== pwWdh) {
    alert('Password and confirm password are different!')
    registerBtn.classList.remove("loading")
    return
  }

  const tid = getParameterByName('tid')


  //this needs to be the same hash algorithm than the login,register and user self pw change (see pwHelper)
  const hashedPw: any = CryptoJS.SHA512(pw)

  const obj = {
    tid: tid,
    pw: hashedPw.toString(CryptoJS.enc.Hex)
  }


  fetch('/api/auth/register/external', {
    method: 'POST',
    body: JSON.stringify(obj),
    headers: {
      'Content-Type': 'application/json; charset=UTF-8',
    },
  })
    .then((response) => {

      if (response.ok === false) {
        registerBtn.classList.remove("loading")

        console.error(response)
        alert(`Some error occurred: ${response.statusText}`)
        return
      }

      response.json()
        .then((response: import('../../src/types/response').ServerResponse) => {

          if (response.code !== 0) {

            registerBtn.classList.remove("loading")

            console.error(response)
            alert(`Some server occurred: ${response.message}`)
            return
          }

          registerBtn.classList.remove("loading")

          console.log(response)

          alert('Password was successfully set.\nYou are automatically redirected to sing in.')

          //TOOD maybe make this dynamic??
          window.location.href = 'index_deploy.html'

      })
        .catch((err) => {
          registerBtn.classList.remove("loading")

          console.error(err)
          alert(`Error parsing json, see console`)
          return
        })

    })
    .catch(function() {
      registerBtn.classList.remove("loading")

      //network error
      alert('Network error?')
    })

}

